//This is some code I put together to test Vector Arrays for Modulus Coprime 6. 
//Obviously if it is not divisor 1, then they aren't Co-Prime. Ie see "Ken Ono" congruences
//Ie " Result expanded to include congruences for every modulus coprime to 6  "
// The Vector reserve() function can be used to eliminate reallocations
//if the number of elements is known beforehand. So I test this for Type !
//Not very efficient, but shows Type is 'value', hence 'size_t CoPrime' for %

#include <iostream>
#include <vector>
#include <cassert>
#include <type_traits>

template<size_t N, typename T>
T average(const std::vector<T>& values)
{
    static_assert(std::is_arithmetic_v<T>,
        "Type parameter for average() must be arithmetic.");
    assert(!values.empty());   
   size_t CoPrime = 0;  
   T sum{}; //I put these in for show,could be a Truple. (Compile time ? )
   T sum1{};//Again algorithm could be improved vastly.(Ie. Euclidean Algorithm )
    for (auto& value : values) {
        if (N > value) { CoPrime = value; }
        if (N < value) { CoPrime = N; }
            for (int i = 1; i <= CoPrime; ++i) {
                if ((CoPrime % i == 0) && (N % i == 0)) {
                    std::cout << "For Number in Array  " << value << std::endl;
                    std::cout << "Common factor  " << i << std::endl;
                }
                if (i == value){ std::cout << "Highest Common factor in integers " << i << std::endl; 
                sum1 = (value - N);
                std::cout << "a is congruent to b modulo m, So a - b = " << abs(sum1) << std::endl;
                }
            }
        sum += 1;
    }   
        return sum; 
}

int main() {
    std::vector<double> vectorData{ 7, 31, 11, 67, 192, 270};//HCF Integers to be compared. Ie Coprime 6 ?
    std::cout << "The number of integers in Vector is  " << average<270>(vectorData) << std::endl; //HCF Comparison Integer
}
